MSYS: local clone must use the drive letter in absolute paths.
[git/dscho.git] / git-clone.sh
blobb62fd24d21b0fd9a698ebaeee926d1d5316cb083
1 #!/bin/sh
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 OPTIONS_SPEC="\
12 git-clone [options] [--] <repo> [<dir>]
14 n,no-checkout don't create a checkout
15 bare create a bare repository
16 naked create a bare repository
17 l,local to clone from a local repository
18 no-hardlinks don't use local hardlinks, always copy
19 s,shared setup as a shared repository
20 template= path to the template directory
21 q,quiet be quiet
22 reference= reference repository
23 o,origin= use <name> instead of 'origin' to track upstream
24 u,upload-pack= path to git-upload-pack on the remote
25 depth= create a shallow clone of that depth
27 use-separate-remote compatibility, do not use
28 no-separate-remote compatibility, do not use"
30 die() {
31 echo >&2 "$@"
32 exit 1
35 # Fix some commands on Windows
36 case $(uname -s) in
37 *MINGW*)
38 # Windows has its own (incompatible) find
39 find () {
40 /usr/bin/find "$@"
42 # need an emulation of cpio
43 cpio() {
44 case "$1" in
45 -pumd) cp_arg=-pr;;
46 -pumdl) cp_arg=-lr;;
47 *) die "cpio $1 unexpected";;
48 esac
49 # copy only files and empty directories
50 prev=
51 while read f; do
52 if test -d "$f"; then
53 # here we assume that directories are listed after
54 # its files (aka 'find -depth'), hence, a directory
55 # that is not empty will be a leading sub-string
56 # of the preceding entry
57 case "$prev" in
58 "$f"/* ) ;;
59 *) echo "$f";;
60 esac
61 else
62 echo "$f"
64 prev="$f"
65 done |
66 xargs --no-run-if-empty \
67 cp $cp_arg --target-directory="$2" --parents
69 # pwd must return a path with a drive letter
70 bin_pwd() {
71 # there are no symlinks to resolve: /bin/pwd is not needed
72 builtin pwd -W
74 pwd() {
75 builtin pwd -W
79 bin_pwd() {
80 /bin/pwd
83 esac
85 usage() {
86 exec "$0" -h
89 eval "$(echo "$OPTIONS_SPEC" | git rev-parse --parseopt -- "$@" || echo exit $?)"
91 get_repo_base() {
93 cd "$(bin_pwd)" &&
94 cd "$1" || cd "$1.git" &&
96 cd .git
97 pwd
99 ) 2>/dev/null
102 if [ -n "$GIT_SSL_NO_VERIFY" -o \
103 "`git config --bool http.sslVerify`" = false ]; then
104 curl_extra_args="-k"
107 http_fetch () {
108 # $1 = Remote, $2 = Local
109 curl -nsfL $curl_extra_args "$1" >"$2"
110 curl_exit_status=$?
111 case $curl_exit_status in
112 126|127) exit ;;
113 *) return $curl_exit_status ;;
114 esac
117 clone_dumb_http () {
118 # $1 - remote, $2 - local
119 cd "$2" &&
120 clone_tmp="$GIT_DIR/clone-tmp" &&
121 mkdir -p "$clone_tmp" || exit 1
122 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
123 "`git config --bool http.noEPSV`" = true ]; then
124 curl_extra_args="${curl_extra_args} --disable-epsv"
126 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
127 die "Cannot get remote repository information.
128 Perhaps git-update-server-info needs to be run there?"
129 test "z$quiet" = z && v=-v || v=
130 while read sha1 refname
132 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
133 case "$name" in
134 *^*) continue;;
135 esac
136 case "$bare,$name" in
137 yes,* | ,heads/* | ,tags/*) ;;
138 *) continue ;;
139 esac
140 if test -n "$use_separate_remote" &&
141 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
142 then
143 tname="remotes/$origin/$branch_name"
144 else
145 tname=$name
147 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
148 done <"$clone_tmp/refs"
149 rm -fr "$clone_tmp"
150 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
151 rm -f "$GIT_DIR/REMOTE_HEAD"
152 if test -f "$GIT_DIR/REMOTE_HEAD"; then
153 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
154 case "$head_sha1" in
155 'ref: refs/'*)
158 git-http-fetch $v -a "$head_sha1" "$1" ||
159 rm -f "$GIT_DIR/REMOTE_HEAD"
161 esac
165 quiet=
166 local=no
167 use_local_hardlink=yes
168 local_shared=no
169 unset template
170 no_checkout=
171 upload_pack=
172 bare=
173 reference=
174 origin=
175 origin_override=
176 use_separate_remote=t
177 depth=
178 no_progress=
179 local_explicitly_asked_for=
180 test -t 1 || no_progress=--no-progress
182 while test $# != 0
184 case "$1" in
185 -n|--no-checkout)
186 no_checkout=yes ;;
187 --naked|--bare)
188 bare=yes ;;
189 -l|--local)
190 local_explicitly_asked_for=yes
191 use_local_hardlink=yes
193 --no-hardlinks)
194 use_local_hardlink=no ;;
195 -s|--shared)
196 local_shared=yes ;;
197 --template)
198 shift; template="--template=$1" ;;
199 -q|--quiet)
200 quiet=-q ;;
201 --use-separate-remote|--no-separate-remote)
202 die "clones are always made with separate-remote layout" ;;
203 --reference)
204 shift; reference="$1" ;;
205 -o|--origin)
206 shift;
207 case "$1" in
209 usage ;;
210 */*)
211 die "'$1' is not suitable for an origin name"
212 esac
213 git check-ref-format "heads/$1" ||
214 die "'$1' is not suitable for a branch name"
215 test -z "$origin_override" ||
216 die "Do not give more than one --origin options."
217 origin_override=yes
218 origin="$1"
220 -u|--upload-pack)
221 shift
222 upload_pack="--upload-pack=$1" ;;
223 --depth)
224 shift
225 depth="--depth=$1" ;;
227 shift
228 break ;;
230 usage ;;
231 esac
232 shift
233 done
235 repo="$1"
236 test -n "$repo" ||
237 die 'you must specify a repository to clone.'
239 # --bare implies --no-checkout and --no-separate-remote
240 if test yes = "$bare"
241 then
242 if test yes = "$origin_override"
243 then
244 die '--bare and --origin $origin options are incompatible.'
246 no_checkout=yes
247 use_separate_remote=
250 if test -z "$origin"
251 then
252 origin=origin
255 # Turn the source into an absolute path if
256 # it is local
257 if base=$(get_repo_base "$repo"); then
258 repo="$base"
259 if test -z "$depth"
260 then
261 local=yes
265 dir="$2"
266 # Try using "humanish" part of source repo if user didn't specify one
267 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
268 [ -e "$dir" ] && die "destination directory '$dir' already exists."
269 [ yes = "$bare" ] && unset GIT_WORK_TREE
270 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
271 die "working tree '$GIT_WORK_TREE' already exists."
274 cleanup() {
275 err=$?
276 test -z "$D" && rm -rf "$dir"
277 test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
278 cd ..
279 test -n "$D" && rm -rf "$D"
280 test -n "$W" && rm -rf "$W"
281 exit $err
283 trap cleanup 0
284 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
285 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
286 W=$(cd "$GIT_WORK_TREE" && pwd) && GIT_WORK_TREE="$W" && export GIT_WORK_TREE
287 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
288 GIT_DIR="$D"
289 else
290 GIT_DIR="$D/.git"
291 fi &&
292 export GIT_DIR &&
293 GIT_CONFIG="$GIT_DIR/config" git-init $quiet ${template+"$template"} || usage
295 if test -n "$bare"
296 then
297 GIT_CONFIG="$GIT_DIR/config" git config core.bare true
300 if test -n "$reference"
301 then
302 ref_git=
303 if test -d "$reference"
304 then
305 if test -d "$reference/.git/objects"
306 then
307 ref_git="$reference/.git"
308 elif test -d "$reference/objects"
309 then
310 ref_git="$reference"
313 if test -n "$ref_git"
314 then
315 ref_git=$(cd "$ref_git" && pwd)
316 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
318 GIT_DIR="$ref_git" git for-each-ref \
319 --format='%(objectname) %(*objectname)'
321 while read a b
323 test -z "$a" ||
324 git update-ref "refs/reference-tmp/$a" "$a"
325 test -z "$b" ||
326 git update-ref "refs/reference-tmp/$b" "$b"
327 done
328 else
329 die "reference repository '$reference' is not a local directory."
333 rm -f "$GIT_DIR/CLONE_HEAD"
335 # We do local magic only when the user tells us to.
336 case "$local" in
337 yes)
338 ( cd "$repo/objects" ) ||
339 die "cannot chdir to local '$repo/objects'."
341 if test "$local_shared" = yes
342 then
343 mkdir -p "$GIT_DIR/objects/info"
344 echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
345 else
346 l= &&
347 if test "$use_local_hardlink" = yes
348 then
349 # See if we can hardlink and drop "l" if not.
350 sample_file=$(cd "$repo" && \
351 find objects -type f -print | sed -e 1q)
352 # objects directory should not be empty because
353 # we are cloning!
354 test -f "$repo/$sample_file" ||
355 die "fatal: cannot clone empty repository"
356 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
357 then
358 rm -f "$GIT_DIR/objects/sample"
360 elif test -n "$local_explicitly_asked_for"
361 then
362 echo >&2 "Warning: -l asked but cannot hardlink to $repo"
364 fi &&
365 cd "$repo" &&
366 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
368 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
371 case "$repo" in
372 rsync://*)
373 case "$depth" in
374 "") ;;
375 *) die "shallow over rsync not supported" ;;
376 esac
377 rsync $quiet -av --ignore-existing \
378 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
379 exit
380 # Look at objects/info/alternates for rsync -- http will
381 # support it natively and git native ones will do it on the
382 # remote end. Not having that file is not a crime.
383 rsync -q "$repo/objects/info/alternates" \
384 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
385 rm -f "$GIT_DIR/TMP_ALT"
386 if test -f "$GIT_DIR/TMP_ALT"
387 then
388 ( cd "$D" &&
389 . git-parse-remote &&
390 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
391 while read alt
393 case "$alt" in 'bad alternate: '*) die "$alt";; esac
394 case "$quiet" in
395 '') echo >&2 "Getting alternate: $alt" ;;
396 esac
397 rsync $quiet -av --ignore-existing \
398 --exclude info "$alt" "$GIT_DIR/objects" || exit
399 done
400 rm -f "$GIT_DIR/TMP_ALT"
402 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
404 https://*|http://*|ftp://*)
405 case "$depth" in
406 "") ;;
407 *) die "shallow over http or ftp not supported" ;;
408 esac
409 if test -z "@@NO_CURL@@"
410 then
411 clone_dumb_http "$repo" "$D"
412 else
413 die "http transport not supported, rebuild Git with curl support"
417 case "$upload_pack" in
418 '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
419 *) git-fetch-pack --all -k $quiet "$upload_pack" $depth $no_progress "$repo" ;;
420 esac >"$GIT_DIR/CLONE_HEAD" ||
421 die "fetch-pack from '$repo' failed."
423 esac
425 esac
426 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
428 if test -f "$GIT_DIR/CLONE_HEAD"
429 then
430 # Read git-fetch-pack -k output and store the remote branches.
431 if [ -n "$use_separate_remote" ]
432 then
433 branch_top="remotes/$origin"
434 else
435 branch_top="heads"
437 tag_top="tags"
438 while read sha1 name
440 case "$name" in
441 *'^{}')
442 continue ;;
443 HEAD)
444 destname="REMOTE_HEAD" ;;
445 refs/heads/*)
446 destname="refs/$branch_top/${name#refs/heads/}" ;;
447 refs/tags/*)
448 destname="refs/$tag_top/${name#refs/tags/}" ;;
450 continue ;;
451 esac
452 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
453 done < "$GIT_DIR/CLONE_HEAD"
456 if test -n "$W"; then
457 cd "$W" || exit
458 else
459 cd "$D" || exit
462 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
463 then
464 # a non-bare repository is always in separate-remote layout
465 remote_top="refs/remotes/$origin"
466 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
467 case "$head_sha1" in
468 'ref: refs/'*)
469 # Uh-oh, the remote told us (http transport done against
470 # new style repository with a symref HEAD).
471 # Ideally we should skip the guesswork but for now
472 # opt for minimum change.
473 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
474 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
476 esac
478 # The name under $remote_top the remote HEAD seems to point at.
479 head_points_at=$(
481 test -f "$GIT_DIR/$remote_top/master" && echo "master"
482 cd "$GIT_DIR/$remote_top" &&
483 find . -type f -print | sed -e 's/^\.\///'
484 ) | (
485 done=f
486 while read name
488 test t = $done && continue
489 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
490 if test "$head_sha1" = "$branch_tip"
491 then
492 echo "$name"
493 done=t
495 done
499 # Upstream URL
500 git config remote."$origin".url "$repo" &&
502 # Set up the mappings to track the remote branches.
503 git config remote."$origin".fetch \
504 "+refs/heads/*:$remote_top/*" '^$' &&
506 # Write out remote.$origin config, and update our "$head_points_at".
507 case "$head_points_at" in
509 # Local default branch
510 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
512 # Tracking branch for the primary branch at the remote.
513 git update-ref HEAD "$head_sha1" &&
515 rm -f "refs/remotes/$origin/HEAD"
516 git symbolic-ref "refs/remotes/$origin/HEAD" \
517 "refs/remotes/$origin/$head_points_at" &&
519 git config branch."$head_points_at".remote "$origin" &&
520 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
523 # Source had detached HEAD pointing nowhere
524 git update-ref --no-deref HEAD "$head_sha1" &&
525 rm -f "refs/remotes/$origin/HEAD"
527 esac
529 case "$no_checkout" in
531 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
532 git read-tree -m -u $v HEAD HEAD
533 esac
535 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
537 trap - 0